unit comtest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, com485, ExtCtrls, savepos, Menus, ListenOptions;

type
  TComTestForm = class(TForm)
    TimerRead: TTimer;
    Panel1: TPanel;
    LabelHex: TLabel;
    Read: TLabel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    EditSend: TEdit;
    ButtonSend: TButton;
    ButtonClear: TButton;
    EditHex: TEdit;
    ButtonSendHex: TButton;
    SavePos: TSavePos;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    mnuOptions: TMenuItem;
    mnu485Options: TMenuItem;
    Label1: TLabel;
    EditPrefix: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EditPostfix: TEdit;
    ButtonListen: TButton;
    mnuListenOptions: TMenuItem;
    procedure ButtonOptionsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonSendClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
    procedure TimerReadTimer(Sender: TObject);
    procedure ButtonSendHexClick(Sender: TObject);
    procedure mnu485OptionsClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuListenOptionsClick(Sender: TObject);
    procedure ButtonListenClick(Sender: TObject);
  private
    ListenStatus:boolean;
    procedure SetListenStatus(status:boolean);
    { Private declarations }
  public
    com : TCom485;
    { Public declarations }
  end;

var
  ComTestForm: TComTestForm;

implementation

{$R *.DFM}
const crlf = #13#10;


procedure TComTestForm.ButtonOptionsClick(Sender: TObject);
begin
  com.Show;
end;

procedure TComTestForm.FormCreate(Sender: TObject);
begin
  Com := TCom485.Create(self);
  Com.OpenPort;
end;

procedure TComTestForm.FormDestroy(Sender: TObject);
begin
  Com.Destroy;
end;

function HexToString(const source:string):ShortString;
var s,h:string; len,i:integer; r:ShortString;
begin
  s := source;
  len := Length(source);
  r := '';
  i := 1;
  while ( i < len ) do begin
    if ( Pos(s[i],'$ ,;/|') > 0 ) then begin i := i + 1; continue; end;
    h := '$' + s[i] + s[i+1]; i := i + 2;
    r := r + Char(StrToInt(h));
  end;

  result:=r;
end;

procedure TComTestForm.ButtonSendClick(Sender: TObject);
var OldStatus:boolean;
begin
  OldStatus:=ListenStatus;
  if FormListenOptions.CBAutoListen.Checked then begin
     SetListenStatus(false);
  end;

  Com.Write(HexToString(EditPrefix.Text)+EditSend.Text+HexToString(EditPostfix.Text));

  if FormListenOptions.CBAutoListen.Checked then begin
     SetListenStatus(OldStatus);
  end;
end;

procedure TComTestForm.ButtonSendHexClick(Sender: TObject);
var OldStatus:boolean;
begin
  OldStatus:=ListenStatus;
  if FormListenOptions.CBAutoListen.Checked then begin
     SetListenStatus(false);
  end;

  Com.Write(HexToString(EditPrefix.Text)+HexToString(EditHex.text)+HexToString(EditPostfix.Text));

  if FormListenOptions.CBAutoListen.Checked then begin
     SetListenStatus(OldStatus);
  end;
end;

procedure TComTestForm.ButtonClearClick(Sender: TObject);
begin
  Read.Caption := '';
  LabelHex.Caption := '';
end;

procedure TComTestForm.ButtonListenClick(Sender: TObject);
begin
  SetListenStatus(not ListenStatus);
end;

procedure TComTestForm.SetListenStatus(status:boolean);
begin
  ListenStatus:=status;
  if ( ListenStatus ) then begin
    if ( FormListenOptions.CBSetDTR.Checked ) then com.DoSetDTR(true);
    if ( FormListenOptions.CBSetRTS.Checked ) then com.DoSetRTS(true);
    ButtonListen.Caption:='No &Listen';
  end else begin
    if ( FormListenOptions.CBClearDTR.Checked ) then com.DoSetDTR(false);
    if ( FormListenOptions.CBClearRTS.Checked ) then com.DoSetRTS(false);
    ButtonListen.Caption:='&Listen';
  end;
end;

procedure TComTestForm.TimerReadTimer(Sender: TObject);
var n : integer; s: ShortString;
begin
  n := Com.InCount;
  if ( n <= 0 ) then exit;
  s := Com.ReadN(n);
  Read.Caption := Read.Caption + s;
  LabelHex.Caption := LabelHex.Caption + StrToHexStr(s);
end;

procedure TComTestForm.mnu485OptionsClick(Sender: TObject);
begin
  com.Show;
end;

procedure TComTestForm.mnuExitClick(Sender: TObject);
begin
     ComTestForm.Close;
end;

procedure TComTestForm.mnuListenOptionsClick(Sender: TObject);
begin
   FormListenOptions.show;
end;


end.
